# biotmed_organization_sdk
APIs document (version: 9.2.19)

This Python package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 9.2.19
- Package version: 0.1.0
- Generator version: 7.7.0
- Build package: org.openapitools.codegen.languages.PythonClientCodegen

## Requirements.

Python 3.7+

## Installation & Usage
### pip install

If the python package is hosted on a repository, you can install directly using:

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import biotmed_organization_sdk
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import biotmed_organization_sdk
```

### Tests

Execute `pytest` to run the tests.

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python

import biotmed_organization_sdk
from biotmed_organization_sdk.rest import ApiException
from pprint import pprint

# Defining the host is optional and defaults to /organization
# See configuration.py for a list of all supported configuration parameters.
configuration = biotmed_organization_sdk.Configuration(
    host = "/organization"
)

# The client must configure the authentication and authorization parameters
# in accordance with the API server security policy.
# Examples for each auth method are provided below, use the example that
# satisfies your auth use case.

# Configure Bearer authorization (JWT): bearerAuth
configuration = biotmed_organization_sdk.Configuration(
    access_token = os.environ["BEARER_TOKEN"]
)


# Enter a context with an instance of the API client
with biotmed_organization_sdk.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = biotmed_organization_sdk.BuiltInTemplatesAPIApi(api_client)

    try:
        # Get built in templates ids
        api_response = api_instance.get_built_in_template()
        print("The response of BuiltInTemplatesAPIApi->get_built_in_template:\n")
        pprint(api_response)
    except ApiException as e:
        print("Exception when calling BuiltInTemplatesAPIApi->get_built_in_template: %s\n" % e)

```

## Documentation for API Endpoints

All URIs are relative to */organization*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*BuiltInTemplatesAPIApi* | [**get_built_in_template**](docs/BuiltInTemplatesAPIApi.md#get_built_in_template) | **GET** /v1/built-in-templates | Get built in templates ids
*CaregiverAPIApi* | [**change_caregiver_enabled_state**](docs/CaregiverAPIApi.md#change_caregiver_enabled_state) | **POST** /v1/users/caregivers/{id}/enabled-state/{state} | Enable or Disable Caregiver User
*CaregiverAPIApi* | [**create_caregiver**](docs/CaregiverAPIApi.md#create_caregiver) | **POST** /v1/users/caregivers | Create a new Caregiver by Template id
*CaregiverAPIApi* | [**create_caregiver_by_template_name**](docs/CaregiverAPIApi.md#create_caregiver_by_template_name) | **POST** /v1/users/caregivers/templates/{templateName} | Create a new Caregiver by Template name
*CaregiverAPIApi* | [**delete_caregiver**](docs/CaregiverAPIApi.md#delete_caregiver) | **DELETE** /v1/users/caregivers/{id} | Delete Caregiver
*CaregiverAPIApi* | [**get_caregiver**](docs/CaregiverAPIApi.md#get_caregiver) | **GET** /v1/users/caregivers/{id} | Get Caregiver by ID
*CaregiverAPIApi* | [**get_caregiver_self**](docs/CaregiverAPIApi.md#get_caregiver_self) | **GET** /v1/users/caregivers/self | Get self Caregiver by ID from access token
*CaregiverAPIApi* | [**search_caregivers**](docs/CaregiverAPIApi.md#search_caregivers) | **GET** /v1/users/caregivers | Search Caregiver entities by filter
*CaregiverAPIApi* | [**update_caregiver**](docs/CaregiverAPIApi.md#update_caregiver) | **PATCH** /v1/users/caregivers/{id} | Update Caregiver
*HealthCheckAPIApi* | [**health_check**](docs/HealthCheckAPIApi.md#health_check) | **GET** /system/healthCheck | Service Health check API
*InternalEntityAPIApi* | [**has_only_built_in_data**](docs/InternalEntityAPIApi.md#has_only_built_in_data) | **GET** /v1/internal/entity-types/{entityTypeName}/has-only-built-in-data | Check if the service has only built in data.
*InternalEntityAPIApi* | [**is_attribute_and_template_in_use**](docs/InternalEntityAPIApi.md#is_attribute_and_template_in_use) | **GET** /v1/internal/entity-types/{entityTypeName}/templates/{templateId}/in-use | Check if custom/built-in attributes and template are in use.
*InvitationAPIApi* | [**resend_invitation**](docs/InvitationAPIApi.md#resend_invitation) | **POST** /v1/invitations/{userId} | Resend Invitation by ID
*LandingPageAPIApi* | [**delete_landing_pages**](docs/LandingPageAPIApi.md#delete_landing_pages) | **DELETE** /v1/landing-pages/{landingPageType} | Delete landing pages by type
*LandingPageAPIApi* | [**get_landing_pages**](docs/LandingPageAPIApi.md#get_landing_pages) | **GET** /v1/landing-pages/{landingPageType} | Get landing pages by type
*LandingPageAPIApi* | [**set_landing_pages**](docs/LandingPageAPIApi.md#set_landing_pages) | **PUT** /v1/landing-pages/{landingPageType} | Set a landing page
*OrganizationAPIApi* | [**change_organization_admin**](docs/OrganizationAPIApi.md#change_organization_admin) | **POST** /v1/organizations/admin/{newAdminId} | Update Organization
*OrganizationAPIApi* | [**create_first_organization**](docs/OrganizationAPIApi.md#create_first_organization) | **POST** /v1/organizations/first | Create First Organization
*OrganizationAPIApi* | [**create_organization**](docs/OrganizationAPIApi.md#create_organization) | **POST** /v1/organizations | Create a new Organization by Template id
*OrganizationAPIApi* | [**create_organization_by_template_name**](docs/OrganizationAPIApi.md#create_organization_by_template_name) | **POST** /v1/organizations/templates/{templateName} | Create a new Organization by Template name
*OrganizationAPIApi* | [**delete_organization**](docs/OrganizationAPIApi.md#delete_organization) | **DELETE** /v1/organizations/{id} | Delete Organization
*OrganizationAPIApi* | [**get_organization**](docs/OrganizationAPIApi.md#get_organization) | **GET** /v1/organizations/{id} | Get Organization by ID
*OrganizationAPIApi* | [**search_organizations**](docs/OrganizationAPIApi.md#search_organizations) | **GET** /v1/organizations | Search Organization entities by filter
*OrganizationAPIApi* | [**update_organization**](docs/OrganizationAPIApi.md#update_organization) | **PATCH** /v1/organizations/{id} | Update Organization
*OrganizationUserAPIApi* | [**change_organization_user_enabled_state**](docs/OrganizationUserAPIApi.md#change_organization_user_enabled_state) | **POST** /v1/users/organizations/{id}/enabled-state/{state} | Enable or Disable Organization User
*OrganizationUserAPIApi* | [**create_organization_user**](docs/OrganizationUserAPIApi.md#create_organization_user) | **POST** /v1/users/organizations | Create a new Organization User by Template id
*OrganizationUserAPIApi* | [**create_organization_user_by_template_name**](docs/OrganizationUserAPIApi.md#create_organization_user_by_template_name) | **POST** /v1/users/organizations/templates/{templateName} | Create a new Organization User by Template name
*OrganizationUserAPIApi* | [**delete_organization_user**](docs/OrganizationUserAPIApi.md#delete_organization_user) | **DELETE** /v1/users/organizations/{id} | Delete Organization User
*OrganizationUserAPIApi* | [**get_organization_user**](docs/OrganizationUserAPIApi.md#get_organization_user) | **GET** /v1/users/organizations/{id} | Get Organization User by ID
*OrganizationUserAPIApi* | [**get_organization_user_self**](docs/OrganizationUserAPIApi.md#get_organization_user_self) | **GET** /v1/users/organizations/self | Get self Organization User by ID from access token
*OrganizationUserAPIApi* | [**search_organization_users**](docs/OrganizationUserAPIApi.md#search_organization_users) | **GET** /v1/users/organizations | Search Organization User entities by filter
*OrganizationUserAPIApi* | [**update_organization_user**](docs/OrganizationUserAPIApi.md#update_organization_user) | **PATCH** /v1/users/organizations/{id} | Update Organization User
*PatientAPIApi* | [**anonymous_sign_up_patient**](docs/PatientAPIApi.md#anonymous_sign_up_patient) | **POST** /v1/users/patients/sign-up/anonymous | Patient Anonymous Sign Up
*PatientAPIApi* | [**change_patient_enabled_state**](docs/PatientAPIApi.md#change_patient_enabled_state) | **POST** /v1/users/patients/{id}/enabled-state/{state} | Enable or Disable Patient User
*PatientAPIApi* | [**create_patient**](docs/PatientAPIApi.md#create_patient) | **POST** /v1/users/patients | Create a new Patient by Template id
*PatientAPIApi* | [**create_patient_by_template_name**](docs/PatientAPIApi.md#create_patient_by_template_name) | **POST** /v1/users/patients/templates/{templateName} | Create a new Patient by Template name
*PatientAPIApi* | [**delete_patient**](docs/PatientAPIApi.md#delete_patient) | **DELETE** /v1/users/patients/{id} | Delete Patient
*PatientAPIApi* | [**get_patient**](docs/PatientAPIApi.md#get_patient) | **GET** /v1/users/patients/{id} | Get Patient by ID
*PatientAPIApi* | [**get_patient_self**](docs/PatientAPIApi.md#get_patient_self) | **GET** /v1/users/patients/self | Get self Patient by ID from access token
*PatientAPIApi* | [**search_available_organizations_for_sign_up**](docs/PatientAPIApi.md#search_available_organizations_for_sign_up) | **GET** /v1/users/patients/sign-up/organizations | Search available organizations for sign up entities by filter
*PatientAPIApi* | [**search_patients**](docs/PatientAPIApi.md#search_patients) | **GET** /v1/users/patients | Search Patient entities by filter
*PatientAPIApi* | [**self_sign_up_patient**](docs/PatientAPIApi.md#self_sign_up_patient) | **POST** /v1/users/patients/sign-up | Patient Self Sign Up
*PatientAPIApi* | [**update_patient**](docs/PatientAPIApi.md#update_patient) | **PATCH** /v1/users/patients/{id} | Update Patient
*PatientAlertAPIApi* | [**create_alert**](docs/PatientAlertAPIApi.md#create_alert) | **POST** /v1/users/patients/{patientId}/alerts | Create a new Patient Alert by Template id
*PatientAlertAPIApi* | [**create_alert_by_template_name**](docs/PatientAlertAPIApi.md#create_alert_by_template_name) | **POST** /v1/users/patients/{patientId}/alerts/{templateName} | Create a new Patient Alert by Template name
*PatientAlertAPIApi* | [**delete_alert**](docs/PatientAlertAPIApi.md#delete_alert) | **DELETE** /v1/users/patients/{patientId}/alerts/{id} | Delete Patient Alert
*PatientAlertAPIApi* | [**get_alert**](docs/PatientAlertAPIApi.md#get_alert) | **GET** /v1/users/patients/{patientId}/alerts/{id} | Get Patient Alert by ID
*PatientAlertAPIApi* | [**search_alerts**](docs/PatientAlertAPIApi.md#search_alerts) | **GET** /v1/users/patients/alerts | Search Patient Alert entities by filter
*PatientAlertAPIApi* | [**search_current_alerts**](docs/PatientAlertAPIApi.md#search_current_alerts) | **GET** /v1/users/patients/current/alerts | Search open patient&#39;s alerts entities by filter
*PatientAlertAPIApi* | [**update_alert**](docs/PatientAlertAPIApi.md#update_alert) | **PATCH** /v1/users/patients/{patientId}/alerts/{id} | Update Patient Alert
*RegistrationCodeAPIApi* | [**create_registration_code**](docs/RegistrationCodeAPIApi.md#create_registration_code) | **POST** /v1/registration-codes | Create a new Registration Code by Template id
*RegistrationCodeAPIApi* | [**create_registration_code_by_template_name**](docs/RegistrationCodeAPIApi.md#create_registration_code_by_template_name) | **POST** /v1/registration-codes/templates/{templateName} | Create a new Registration Code by Template name
*RegistrationCodeAPIApi* | [**delete_registration_code**](docs/RegistrationCodeAPIApi.md#delete_registration_code) | **DELETE** /v1/registration-codes/{id} | Delete Registration Code
*RegistrationCodeAPIApi* | [**get_registration_code**](docs/RegistrationCodeAPIApi.md#get_registration_code) | **GET** /v1/registration-codes/{id} | Get Registration Code by ID
*RegistrationCodeAPIApi* | [**search_registration_codes**](docs/RegistrationCodeAPIApi.md#search_registration_codes) | **GET** /v1/registration-codes | Search Registration Code entities by filter
*RegistrationCodeAPIApi* | [**update_registration_code**](docs/RegistrationCodeAPIApi.md#update_registration_code) | **PATCH** /v1/registration-codes/{id} | Update Registration Code
*SyncTokenPermissionsCoreAPIApi* | [**force_sync_permissions**](docs/SyncTokenPermissionsCoreAPIApi.md#force_sync_permissions) | **POST** /v1/system/permissions/sync | 
*TemporaryTokenOperationAPIApi* | [**execute_token_operation**](docs/TemporaryTokenOperationAPIApi.md#execute_token_operation) | **POST** /v1/tokens/{token} | Execute token operation
*TemporaryTokenOperationAPIApi* | [**execute_token_operation_get**](docs/TemporaryTokenOperationAPIApi.md#execute_token_operation_get) | **GET** /v1/tokens/{token}/execute | Execute token operation
*TemporaryTokenOperationAPIApi* | [**validate_token_operation**](docs/TemporaryTokenOperationAPIApi.md#validate_token_operation) | **GET** /v1/tokens/{token} | Validation token operation
*UserAPIApi* | [**get_self**](docs/UserAPIApi.md#get_self) | **GET** /v1/users/self | Get self User by ID from access token


## Documentation For Models

 - [Address](docs/Address.md)
 - [AddressUpdateRequest](docs/AddressUpdateRequest.md)
 - [BasicEntityData](docs/BasicEntityData.md)
 - [BasicOrganizationResponse](docs/BasicOrganizationResponse.md)
 - [BasicReferencedEntityDataUUIDId](docs/BasicReferencedEntityDataUUIDId.md)
 - [BasicTemplateData](docs/BasicTemplateData.md)
 - [BuiltInDataStatus](docs/BuiltInDataStatus.md)
 - [BuiltInTemplateProps](docs/BuiltInTemplateProps.md)
 - [BuiltInTemplatesResponse](docs/BuiltInTemplatesResponse.md)
 - [CaregiverResponse](docs/CaregiverResponse.md)
 - [CreateAlertByTemplateNameRequest](docs/CreateAlertByTemplateNameRequest.md)
 - [CreateAlertRequest](docs/CreateAlertRequest.md)
 - [CreateCaregiverByTemplateNameRequest](docs/CreateCaregiverByTemplateNameRequest.md)
 - [CreateCaregiverRequest](docs/CreateCaregiverRequest.md)
 - [CreateFirstOrganizationRequest](docs/CreateFirstOrganizationRequest.md)
 - [CreateOrganizationByTemplateNameRequest](docs/CreateOrganizationByTemplateNameRequest.md)
 - [CreateOrganizationRequest](docs/CreateOrganizationRequest.md)
 - [CreateOrganizationUserByTemplateNameRequest](docs/CreateOrganizationUserByTemplateNameRequest.md)
 - [CreateOrganizationUserRequest](docs/CreateOrganizationUserRequest.md)
 - [CreatePatientByTemplateNameRequest](docs/CreatePatientByTemplateNameRequest.md)
 - [CreatePatientRequest](docs/CreatePatientRequest.md)
 - [CreateRegistrationCodeByTemplateNameRequest](docs/CreateRegistrationCodeByTemplateNameRequest.md)
 - [CreateRegistrationCodeRequest](docs/CreateRegistrationCodeRequest.md)
 - [DeleteLandingPageRequest](docs/DeleteLandingPageRequest.md)
 - [ErrorResponse](docs/ErrorResponse.md)
 - [FilterV2](docs/FilterV2.md)
 - [FirstOrganizationAdminUserRequest](docs/FirstOrganizationAdminUserRequest.md)
 - [GetLandingPagesResponse](docs/GetLandingPagesResponse.md)
 - [InvitationResponse](docs/InvitationResponse.md)
 - [LandingPageResponse](docs/LandingPageResponse.md)
 - [Metadata](docs/Metadata.md)
 - [MfaDto](docs/MfaDto.md)
 - [MfaUpdateRequest](docs/MfaUpdateRequest.md)
 - [Name](docs/Name.md)
 - [NameUpdateRequest](docs/NameUpdateRequest.md)
 - [Order](docs/Order.md)
 - [OrganizationAdminUserRequest](docs/OrganizationAdminUserRequest.md)
 - [OrganizationResponse](docs/OrganizationResponse.md)
 - [OrganizationUserResponse](docs/OrganizationUserResponse.md)
 - [PageMetadata](docs/PageMetadata.md)
 - [ParentTemplateResponse](docs/ParentTemplateResponse.md)
 - [PatientAlertResponse](docs/PatientAlertResponse.md)
 - [PatientAnonymousSignUpRequest](docs/PatientAnonymousSignUpRequest.md)
 - [PatientOwnedAlertResponse](docs/PatientOwnedAlertResponse.md)
 - [PatientResponse](docs/PatientResponse.md)
 - [PatientSelfSignUpRequest](docs/PatientSelfSignUpRequest.md)
 - [ReferenceAttributeUUIDIdRequest](docs/ReferenceAttributeUUIDIdRequest.md)
 - [ReferencedSideAttributeInformation](docs/ReferencedSideAttributeInformation.md)
 - [RegistrationCodeResponse](docs/RegistrationCodeResponse.md)
 - [SearchRequestV2](docs/SearchRequestV2.md)
 - [SearchResponseBasicOrganizationResponse](docs/SearchResponseBasicOrganizationResponse.md)
 - [SearchResponseCaregiverResponse](docs/SearchResponseCaregiverResponse.md)
 - [SearchResponseOrganizationResponse](docs/SearchResponseOrganizationResponse.md)
 - [SearchResponseOrganizationUserResponse](docs/SearchResponseOrganizationUserResponse.md)
 - [SearchResponsePatientAlertResponse](docs/SearchResponsePatientAlertResponse.md)
 - [SearchResponsePatientOwnedAlertResponse](docs/SearchResponsePatientOwnedAlertResponse.md)
 - [SearchResponsePatientResponse](docs/SearchResponsePatientResponse.md)
 - [SearchResponseRegistrationCodeResponse](docs/SearchResponseRegistrationCodeResponse.md)
 - [SetLandingPageRequest](docs/SetLandingPageRequest.md)
 - [TemplateAndAttributesInUseResponse](docs/TemplateAndAttributesInUseResponse.md)
 - [TokenOperationRequest](docs/TokenOperationRequest.md)
 - [TokenOperationResponse](docs/TokenOperationResponse.md)
 - [UpdateAlertRequest](docs/UpdateAlertRequest.md)
 - [UpdateCaregiverRequest](docs/UpdateCaregiverRequest.md)
 - [UpdateOrganizationRequest](docs/UpdateOrganizationRequest.md)
 - [UpdateOrganizationUserRequest](docs/UpdateOrganizationUserRequest.md)
 - [UpdatePatientRequest](docs/UpdatePatientRequest.md)
 - [UpdateRegistrationCodeRequest](docs/UpdateRegistrationCodeRequest.md)
 - [UserResponse](docs/UserResponse.md)
 - [VersionResponse](docs/VersionResponse.md)


<a id="documentation-for-authorization"></a>
## Documentation For Authorization


Authentication schemes defined for the API:
<a id="bearerAuth"></a>
### bearerAuth

- **Type**: Bearer authentication (JWT)


## Author




