# coding: utf-8

"""
    BioT Organization Service

    APIs document (version: 9.2.19)

    The version of the OpenAPI document: 9.2.19
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class BasicOrganizationResponse(BaseModel):
    """
    BasicOrganizationResponse
    """ # noqa: E501
    name: Optional[StrictStr] = Field(default=None, description="An organization's name", alias="_name")
    description: Optional[StrictStr] = Field(default=None, description="A description, can be up to 5000 characters long", alias="_description")
    id: Optional[StrictStr] = Field(default=None, description="A UUID formatted string", alias="_id")
    creation_time: Optional[datetime] = Field(default=None, description="A UTC date-time in the ISO-8601 format", alias="_creationTime")
    last_modified_time: Optional[datetime] = Field(default=None, description="A UTC date-time in the ISO-8601 format", alias="_lastModifiedTime")
    caption: Optional[StrictStr] = Field(default=None, alias="_caption")
    __properties: ClassVar[List[str]] = ["_name", "_description", "_id", "_creationTime", "_lastModifiedTime", "_caption"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of BasicOrganizationResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of BasicOrganizationResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "_name": obj.get("_name"),
            "_description": obj.get("_description"),
            "_id": obj.get("_id"),
            "_creationTime": obj.get("_creationTime"),
            "_lastModifiedTime": obj.get("_lastModifiedTime"),
            "_caption": obj.get("_caption")
        })
        return _obj


