# coding: utf-8

"""
    BioT Organization Service

    APIs document (version: 9.2.19)

    The version of the OpenAPI document: 9.2.19
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class LandingPageResponse(BaseModel):
    """
    LandingPageResponse
    """ # noqa: E501
    user_type: StrictStr = Field(description="The type of the user. Can be one of the following: [patient, caregiver, organization-user]", alias="userType")
    organization_id: StrictStr = Field(description="A UUID formatted string", alias="organizationId")
    url: StrictStr = Field(description="The landing page URL")
    landing_page_type: Optional[StrictStr] = Field(default=None, alias="landingPageType")
    __properties: ClassVar[List[str]] = ["userType", "organizationId", "url", "landingPageType"]

    @field_validator('landing_page_type')
    def landing_page_type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['ACCEPT_INVITATION', 'FORGOT_PASSWORD']):
            raise ValueError("must be one of enum values ('ACCEPT_INVITATION', 'FORGOT_PASSWORD')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of LandingPageResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of LandingPageResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "userType": obj.get("userType"),
            "organizationId": obj.get("organizationId"),
            "url": obj.get("url"),
            "landingPageType": obj.get("landingPageType")
        })
        return _obj


