# coding: utf-8

"""
    BioT Organization Service

    APIs document (version: 9.2.19)

    The version of the OpenAPI document: 9.2.19
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from biotmed_organization_sdk.models.filter_v2 import FilterV2
from biotmed_organization_sdk.models.order import Order
from biotmed_organization_sdk.models.page_metadata import PageMetadata
from typing import Optional, Set
from typing_extensions import Self

class Metadata(BaseModel):
    """
    Metadata
    """ # noqa: E501
    sort: Optional[List[Order]] = Field(default=None, description="Sort that was passed in the request")
    filter: Optional[Dict[str, FilterV2]] = Field(default=None, description="The filter that was passed in the request")
    page: Optional[PageMetadata] = None
    free_text_search: Optional[StrictStr] = Field(default=None, description="Free text search strings that was passed in the request", alias="freeTextSearch")
    __properties: ClassVar[List[str]] = ["sort", "filter", "page", "freeTextSearch"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Metadata from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in sort (list)
        _items = []
        if self.sort:
            for _item in self.sort:
                if _item:
                    _items.append(_item.to_dict())
            _dict['sort'] = _items
        # override the default output from pydantic by calling `to_dict()` of each value in filter (dict)
        _field_dict = {}
        if self.filter:
            for _key in self.filter:
                if self.filter[_key]:
                    _field_dict[_key] = self.filter[_key].to_dict()
            _dict['filter'] = _field_dict
        # override the default output from pydantic by calling `to_dict()` of page
        if self.page:
            _dict['page'] = self.page.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Metadata from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "sort": [Order.from_dict(_item) for _item in obj["sort"]] if obj.get("sort") is not None else None,
            "filter": dict(
                (_k, FilterV2.from_dict(_v))
                for _k, _v in obj["filter"].items()
            )
            if obj.get("filter") is not None
            else None,
            "page": PageMetadata.from_dict(obj["page"]) if obj.get("page") is not None else None,
            "freeTextSearch": obj.get("freeTextSearch")
        })
        return _obj


