# coding: utf-8

"""
    BioT Organization Service

    APIs document (version: 9.2.19)

    The version of the OpenAPI document: 9.2.19
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from biotmed_organization_sdk.models.reference_attribute_uuidid_request import ReferenceAttributeUUIDIdRequest
from typing import Optional, Set
from typing_extensions import Self

class PatientAnonymousSignUpRequest(BaseModel):
    """
    PatientAnonymousSignUpRequest
    """ # noqa: E501
    username: StrictStr = Field(description="User's username. Can be an email or a regular username. With this username you login to the system.", alias="_username")
    password: StrictStr = Field(description="A password", alias="_password")
    nickname: Optional[Annotated[str, Field(min_length=1, strict=True, max_length=128)]] = Field(default=None, description="The nickname of the user", alias="_nickname")
    device_registration_code: ReferenceAttributeUUIDIdRequest = Field(alias="_deviceRegistrationCode")
    __properties: ClassVar[List[str]] = ["_username", "_password", "_nickname", "_deviceRegistrationCode"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of PatientAnonymousSignUpRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of device_registration_code
        if self.device_registration_code:
            _dict['_deviceRegistrationCode'] = self.device_registration_code.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of PatientAnonymousSignUpRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "_username": obj.get("_username"),
            "_password": obj.get("_password"),
            "_nickname": obj.get("_nickname"),
            "_deviceRegistrationCode": ReferenceAttributeUUIDIdRequest.from_dict(obj["_deviceRegistrationCode"]) if obj.get("_deviceRegistrationCode") is not None else None
        })
        return _obj


