# coding: utf-8

"""
    BioT Organization Service

    APIs document (version: 9.2.19)

    The version of the OpenAPI document: 9.2.19
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from biotmed_organization_sdk.models.basic_referenced_entity_data_uuidid import BasicReferencedEntityDataUUIDId
from typing import Optional, Set
from typing_extensions import Self

class RegistrationCodeResponse(BaseModel):
    """
    RegistrationCodeResponse
    """ # noqa: E501
    code: StrictStr = Field(alias="_code")
    id: StrictStr = Field(alias="_id")
    last_modified_time: datetime = Field(alias="_lastModifiedTime")
    creation_time: datetime = Field(alias="_creationTime")
    owner_organization: BasicReferencedEntityDataUUIDId = Field(alias="_ownerOrganization")
    caption: Optional[StrictStr] = Field(default=None, alias="_caption")
    __properties: ClassVar[List[str]] = ["_code", "_id", "_lastModifiedTime", "_creationTime", "_ownerOrganization", "_caption"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of RegistrationCodeResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of owner_organization
        if self.owner_organization:
            _dict['_ownerOrganization'] = self.owner_organization.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of RegistrationCodeResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "_code": obj.get("_code"),
            "_id": obj.get("_id"),
            "_lastModifiedTime": obj.get("_lastModifiedTime"),
            "_creationTime": obj.get("_creationTime"),
            "_ownerOrganization": BasicReferencedEntityDataUUIDId.from_dict(obj["_ownerOrganization"]) if obj.get("_ownerOrganization") is not None else None,
            "_caption": obj.get("_caption")
        })
        return _obj


